; Cave-Kernel v0.10
; (C)2003 Thomas Jentzsch

    processor 6502
    include vcs.h


;===============================================================================
; A S S E M B L E R - S W I T C H E S
;===============================================================================


;===============================================================================
; C O N S T A N T S
;===============================================================================

OFS             = 46;+18
OFS2            = OFS/2-3

;BW = 8-1

ID_TOP_HORZ     = 0
ID_TOP_OU       = 1     ;%001
ID_TOP_UO       = 2     ;%010
ID_TOP_OU2      = 3     ;%011
ID_TOP_UO2      = 4     ;%100
ID_TOP_OU3      = 5     ;%101
ID_TOP_UO3      = 6     ;%110

ID_HEIGHT1      = ID_TOP_OU
ID_HEIGHT2      = ID_TOP_OU2
ID_HEIGHT3      = ID_TOP_OU3

RAND_EOR_8      = $b2

NUM_BLOCKS        = 4           ; number of PF-blocks
NUM_SEGS        = NUM_BLOCKS+2  ; number of visible cave segments


;===============================================================================
; Z P - V A R I A B L E S
;===============================================================================

    SEG.U   variables
    ORG     $80

frameCnt    .byte
;scrlDelay   .byte
;scrlSpeed   .byte
random      .byte

tmpVar      .byte
tmpVar2     .byte
tmpVar3     .byte
tmpVar4     .byte
tmpVar5     .byte
tmpVar6     .byte

;---------------------------------------
xOfs        ds 2
xTopOfs     = xOfs
xBtmOfs     = xOfs + 1
yOfs        ds 2
yTopOfs     = yOfs
yBtmOfs     = yOfs + 1

idLst       ds NUM_SEGS  *2
topIdLst    = idLst
btmIdLst    = idLst + NUM_SEGS

widthLst    ds NUM_SEGS  *2
topWidthLst = widthLst
btmWidthLst = widthLst + NUM_SEGS

eorLst      ds NUM_BLOCKS*2
topEorLst   = eorLst
btmEorLst   = eorLst + NUM_BLOCKS

ptrPFLst    ds.w NUM_BLOCKS*4
topPFLst    = ptrPFLst
topPF1_L1   = topPFLst
topPF1_L2   = topPFLst+2
topPF2_L1   = topPFLst+4
topPF2_L2   = topPFLst+6
topPF2_R1   = topPFLst+8
topPF2_R2   = topPFLst+10
topPF1_R1   = topPFLst+12
topPF1_R2   = topPFLst+14

btmPFLst    = ptrPFLst + NUM_BLOCKS*4
btmPF1_L1   = btmPFLst
btmPF1_L2   = btmPFLst+2
btmPF2_L1   = btmPFLst+4
btmPF2_L2   = btmPFLst+6
btmPF2_R1   = btmPFLst+8
btmPF2_R2   = btmPFLst+10
btmPF1_R1   = btmPFLst+12
btmPF1_R2   = btmPFLst+14


;===============================================================================
; M A C R O S
;===============================================================================

  MAC BIT_B
    .byte   $24
  ENDM

  MAC BIT_W
    .byte   $2c
  ENDM

  MAC SLEEP
    IF {1} = 1
      ECHO "ERROR: SLEEP 1 not allowed !"
      END
    ENDIF
    IF {1} & 1
      nop $00
      REPEAT ({1}-3)/2
        nop
      REPEND
    ELSE
      REPEAT ({1})/2
        nop
      REPEND
    ENDIF
  ENDM

  MAC PATTERN_SHR
.V SET {1}
    REPEAT 7
      REPEAT {2}
      .byte .V
      REPEND
     IF .V & $80
.V SET .V/2 + $80
     ELSE
.V SET .V/2
     ENDIF
    REPEND
  ENDM

  MAC PATTERN_SHL
.V SET {1}
    REPEAT 7
      REPEAT {2}
      .byte .V
      REPEND
     IF .V & 1
.V SET .V*2 + 1
     ELSE
.V SET .V*2
     ENDIF
    REPEND
  ENDM


;===============================================================================
; R O M - C O D E
;===============================================================================
    SEG     Bank0
    ORG     $f000

Start SUBROUTINE
    sei                         ;           Disable interrupts, if there are any.
    cld                         ;           Clear BCD math bit.
    ldx     #0
    txs
    pha                         ;           Set stack to beginning.
    txa
.clearLoop:
    pha
    dex
    bne     .clearLoop

    jsr     GameInit

.mainLoop:
    jsr     VerticalBlank
    jsr     GameCalc
    jsr     DrawScreen
    jsr     OverScan
    jmp     .mainLoop


GameInit SUBROUTINE
    lda     #$48
    sta     COLUP0
    lda     #$88
    sta     COLUP1
    lda     #$0c
    sta     COLUPF

    lda     #1
    sta     CTRLPF

    lda     #OFS2
    sta     yTopOfs
    sta     yBtmOfs

;    lda     #ID_TOP_OU
;    sta     topIdLst
;    lda     #ID_TOP_UO
;    sta     topIdLst+1
;    lda     #ID_TOP_OU3
;    sta     topIdLst+2
;    lda     #ID_TOP_HORZ;UO
;    sta     topIdLst+3
;    lda     #ID_TOP_UO2
;    sta     topIdLst+4
;    lda     #ID_TOP_UO
;    sta     topIdLst+5
;
;    lda     #BW
;    sta     topWidthLst
;    lda     #BW+4
;    sta     topWidthLst+1
;    lda     #BW
;    sta     topWidthLst+2
;    lda     #BW+1
;    sta     topWidthLst+3
;    sta     topWidthLst+4
;    sta     topWidthLst+5

    ldx     #NUM_SEGS  *2-1
.loop:
    lda     #ID_TOP_HORZ
    sta     idLst,x
    lda     #7
    sta     widthLst,x
    dex
    bpl     .loop

    inc     random
    rts


VerticalBlank SUBROUTINE
    lda     #2
    sta     WSYNC
    sta     VSYNC
    sta     WSYNC
    sta     WSYNC
    lsr
    ldx     #44
    sta     WSYNC
    sta     VSYNC
    stx     TIM64T
    rts


GetHeight SUBROUTINE
; x = idx
    ldy     idLst,x
GetHeightId:
    lda     DiffTbl,y
    beq     .pos            ; horizontal!
    sta     tmpVar          ; php
    lda     widthLst,x
    cpy     #ID_HEIGHT2
    bcc     .skipQuad
    asl
    cpy     #ID_HEIGHT3
    bcc     .skipQuad
    clc
    adc     widthLst,x
;    asl
.skipQuad:
    bit     tmpVar          ; plp
    bpl     .pos
    eor     #$ff
    clc
    adc     #1
.pos:
    rts


NextSegment SUBROUTINE
; y = 0/1 (top/bottom)
.tmpYOfs    = tmpVar2
.tmpPos     = tmpVar3
.cntLoop    = tmpVar4

    sty     .tmpPos

; reset x-offset:
    lda     #0
    sta     xOfs,y

; calculate new y-offset:
    ldx     SegOfsTbl,y
    jsr     GetHeight
    ldy     .tmpPos
    clc
    adc     yOfs,y
    sta     yOfs,y
    sec
    sbc     #8
    sta     .tmpYOfs

; move blocks and calculate total height:
    lda     #NUM_SEGS  -1
    sta     .cntLoop
.loop:
    lda     widthLst+1,x
    sta     widthLst,x
    ldy     idLst+1,x
    sty     idLst,x
    jsr     GetHeight
    clc
    adc     .tmpYOfs
    sta     .tmpYOfs
    inx
    dec     .cntLoop
    bne     .loop

; get next width:
    jsr     NextRandom
    and     #$07
    tay
    lda     WidthTbl,y
    sta     widthLst,x

; get next direction:
    jsr     NextRandom
    and     #7
    tay
    lda     NewIdTbl,y
    tay
    jsr     GetHeightId
    clc
    adc     .tmpYOfs
    cmp     #OFS-5              ; out of bounds?
    bcc     .setId
    lda     InvertTbl,y         ; invert direction!
    tay
.setId:
    sty     idLst,x
    rts


NewIdTbl:
    .byte   ID_TOP_HORZ
    .byte   ID_TOP_OU,  ID_TOP_UO
    .byte   ID_TOP_OU2, ID_TOP_UO2
    .byte   ID_TOP_OU
    .byte   ID_TOP_OU3, ID_TOP_UO3
  ENDIF

WidthTbl:
    .byte   7, 7,  8,  7
    .byte   7, 8,  7,  9
    .byte   7, 8, 11, 13
    .byte   7, 9, 10, 12


GameCalc SUBROUTINE
    lda     frameCnt
    and     #$01
    bne     .skipTop
;    lda     scrlDelay
;    clc
;    adc     scrlSpeed
;    sta     scrlDelay
;    bcc     .skip

    inc     xTopOfs
    lda     xTopOfs
    cmp     topWidthLst
    bcc     .topOk
    ldy     #0
    jsr     NextSegment
.topOk:
    ldx     #0
    jsr     SetAllPtr
.skipTop:

    rts


SetAllPtr SUBROUTINE
.tmpAdd     = tmpVar2
.ptrIdx     = tmpVar3
.idIdx      = tmpVar4
.tmpYOfs    = tmpVar5
.tmpXOfs    = tmpVar6

    lda     yOfs,x
    sta     .tmpYOfs
    lda     xOfs,x
    sta     .tmpXOfs

    lda     SegOfsTbl,x
    sta     .idIdx
    lda     PtrOfsTbl,x
    sta     .ptrIdx
.loop:
    lsr
    lsr
    sta     tmpVar
;---------------------------------------
    ldx     .idIdx
    lda     .tmpXOfs
    clc
    adc     #8
    cmp     widthLst,x
    bcc     .noEor

    ldy     idLst,x
    lda     DiffTbl,y
    ldy     idLst+1,x
    cmp     DiffTbl,y
    bpl     .noEor
.eor:
    lda     #$ff
    BIT_W
.noEor:
    lda     #$00
    ldx     tmpVar
    sta     eorLst,x            ; 0 |$ff
;---------------------------------------
    lda     #8                  ; right
    jsr     SetPtr
;---------------------------------------
    lda     #0                  ; left
    jsr     SetPtr
;---------------------------------------
    lda     .ptrIdx
    bit     BitTbl
    bne     .loop
    rts

BitTbl:
    .byte   $0c

SetPtr:
    sta     .tmpAdd
;***************************************************************
;GetOffset:
; uses:
; - a, x, y
; - tmpVar
    ldx     .idIdx
    ldy     idLst,x

; Vorzeichen von Offset?
    tya
    beq     .zero               ; HORZ? -> no offset!
    lsr                         ; OU\ | UO/ -> C = 1 | 0
    lda     .tmpXOfs
    bcs     .positive
    eor     #$ff                ; UO/ -> negieren
    adc     #1
.positive:
    sta     tmpVar
; Offset vervielfachen?
    cpy     #ID_HEIGHT2
    bcc     .single
    asl
    cpy     #ID_HEIGHT3
    bcc     .single
    clc
    adc     tmpVar
;    asl
.single:
.zero:
    sta     tmpVar

; left or right part?
    lda     .tmpAdd             ; 8/0
    cmp     #8                  ; -> C=0/1
    tya
    and     #1                  ; up or down?
    beq     .up                 ;  up!
    bcs     .diff               ; down/right
    lsr                         ; -> C=1, A=0
.up:
    bcs     .cont               ; up/right
.diff
    lda     PatHeightTbl,y
.cont:

; Korrektur fr OU\ ?
    clc
    adc     AdjustTbl,y         ; -1/ 0
    clc
    adc     tmpVar
    sta     tmpVar
;***************************************************************
    lda     .ptrIdx
    lsr
    lsr
;    and     #3
    tax
    lsr                         ; odd PF-segment?
    bcc     .skipInvert
    lda     InvertTbl,y         ; invert PF2_L and PF1_R (#1/3)
    tay
.skipInvert:
    lda     eorLst,x
    asl
    lda     PtrLoTbl,y
    bcc     .okLo
    lda     PtrLorTbl,y
.okLo:
    clc
    adc     .tmpYOfs
    clc
    adc     tmpVar
    ldx     .ptrIdx
    sta     ptrPFLst,x
    lda     PtrHiTbl,y          ; must be identical!!!
    sta     ptrPFLst+1,x
    inx
    inx
    stx     .ptrIdx

    ldx     .idIdx
    lda     .tmpAdd
    clc
    adc     .tmpXOfs
    sta     .tmpXOfs
    cmp     widthLst,x
    bcc     .skipInc
    sbc     widthLst,x
    sta     .tmpXOfs

    jsr     GetHeight
    clc
    adc     .tmpYOfs
    sta     .tmpYOfs

    inc     .idIdx
.skipInc:
    rts


DrawScreen SUBROUTINE
    tsx
    stx     tmpVar

    ldx     #228
.waitTim:
    lda     INTIM
    bne     .waitTim
    sta     WSYNC
    sta     VBLANK
    stx     TIM64T
;---------------------------------------------------------------
    sta     WSYNC
    ldy     #OFS-1
.loopTopKernel:                    ;           @56
    sta     WSYNC
    lda     #0                  ; 2
    sta     COLUPF              ; 3 =  5
    SLEEP   44
    lda     (topPF1_R1),y       ; 5
;    SLEEP   5
    and     (topPF1_R2),y       ; 5
    eor     topEorLst+3         ; 3
    tax                         ; 2 = 15
    lda     ColTbl,y            ; 4
    sta     COLUPF              ; 3 =  7
    sty     WSYNC
;-----------------------------------------------
    lda     (topPF1_L1),y       ; 5
    and     (topPF1_L2),y       ; 5
    eor     topEorLst           ; 3
    sta     PF1                 ; 3 = 16    @16
    lda     (topPF2_L1),y       ; 5
    and     (topPF2_L2),y       ; 5
    eor     topEorLst+1         ; 3
    sta     PF2                 ; 3 = 16    @32
    lda     (topPF2_R1),y       ; 5
;    SLEEP   5
    and     (topPF2_R2),y       ; 5
    eor     topEorLst+2         ; 3
    sta     PF2                 ; 3 = 16    @48
    stx     PF1                 ; 3
    dey                         ; 2
    bpl     .loopTopKernel         ; 2= 7/8

    ldy     #OFS-1
.loopBtmKernel:                    ;           @56
    sta     WSYNC
    lda     #0                  ; 2
    sta     COLUPF              ; 3 =  5
    SLEEP   44
    lda     (btmPF1_R1),y       ; 5
;    SLEEP   5
    and     (btmPF1_R2),y       ; 5
    eor     btmEorLst+3         ; 3
    tax                         ; 2 = 15
    lda     ColTbl,y            ; 4
    sta     COLUPF              ; 3 =  7
    sty     WSYNC
;-----------------------------------------------
    lda     (btmPF1_L1),y       ; 5
    and     (btmPF1_L2),y       ; 5
    eor     btmEorLst           ; 3
    sta     PF1                 ; 3 = 16    @16
    lda     (btmPF2_L1),y       ; 5
    and     (btmPF2_L2),y       ; 5
    eor     btmEorLst+1         ; 3
    sta     PF2                 ; 3 = 16    @32
    lda     (btmPF2_R1),y       ; 5
;    SLEEP   5
    and     (btmPF2_R2),y       ; 5
    eor     btmEorLst+2         ; 3
    sta     PF2                 ; 3 = 16    @48
    stx     PF1                 ; 3
    dey                         ; 2
    bpl     .loopBtmKernel         ; 2= 7/8

    iny
    sta     WSYNC
    sty     PF1
    sty     PF2
    lda     #$0a
    sta     COLUPF
    ldx     #0
.wait:
    sta     WSYNC
    dex
    bpl     .wait
    lda     #$81
    sta     PF1
    sta     PF2
    sta     WSYNC
    lda     #0
    sta     PF2
    sta     PF2

;---------------------------------------------------------------
    ldy     #0
    sty     PF0
    sty     PF1
    sty     PF2
    sty     GRP0
    sty     GRP1
    sty     ENAM0
    sty     ENAM1
    sty     ENABL

    ldx     #2
.waitScreen:
    lda     INTIM
    bne     .waitScreen
    sta     WSYNC
    stx     VBLANK

    ldx     tmpVar
    txs
    rts


OverScan SUBROUTINE
    lda     #36
    sta     TIM64T

    lda     SWCHB
    lsr
    bcs     .skipReset
    brk

.skipReset:
    inc     frameCnt
;    bne     .skipSpeed
;    inc     scrlSpeed
;.skipSpeed:

    lda     frameCnt
    and     #$01
    bne     .skipBtm
    inc     xBtmOfs
    lda     xBtmOfs
    cmp     btmWidthLst
    bcc     .btmOk
    ldy     #1
    jsr     NextSegment
.btmOk:
    ldx     #1
    jsr     SetAllPtr

    ldx     #NUM_BLOCKS-1
.loop:
    lda     btmEorLst,x            ; 0 |$ff
    eor     #$ff
    sta     btmEorLst,x            ; 0 |$ff
    dex
    bpl     .loop
.skipBtm:

.waitTim:
    lda     INTIM
    bne     .waitTim
    rts


NextRandom SUBROUTINE
    lda     random              ; 3
    lsr                         ; 2
    bcc     .skipEor            ; 2
    eor     #RAND_EOR_8         ; 2
.skipEor:                       ;   = 11/12 (~11.5)
    sta     random              ; 3
    rts

;===============================================================================
; R O M - T A B L E S (Bank 0)
;===============================================================================
    org     $f800

PtrLoTbl:
    .byte   <PFTop_Horz,  <PFTop_OU,  <PFTop_UO,  <PFTop_OU2,  <PFTop_UO2,  <PFTop_OU3,  <PFTop_UO3
PtrHiTbl:
    .byte   >PFTop_Horz,  >PFTop_OU,  >PFTop_UO,  >PFTop_OU2,  >PFTop_UO2,  >PFTop_OU3,  >PFTop_UO3
PtrLorTbl:
    .byte   <PFTop_Horzr, <PFTop_OUr, <PFTop_UOr, <PFTop_OU2r, <PFTop_UO2r, <PFTop_OU3r, <PFTop_UO3r
PtrHirTbl:
    .byte   >PFTop_Horzr, >PFTop_OUr, >PFTop_UOr, >PFTop_OU2r, >PFTop_UO2r, >PFTop_OU3r, >PFTop_UO3r
PatHeightTbl:
    .byte   0, 8, 8, 8*2, 8*2, 8*3, 8*3   ; immer Vielfaches von 8!
AdjustTbl:
    .byte   0,-1, 0,-2, 0,-3, 0
DiffTbl:
    .byte   0, 1,-1, 2,-2, 3,-3
InvertTbl:
    .byte   ID_TOP_HORZ, ID_TOP_UO, ID_TOP_OU, ID_TOP_UO2, ID_TOP_OU2
    .byte   ID_TOP_UO3, ID_TOP_OU3

ColTbl:
;    .byte  $20, $22, $24, $26, $28, $2a,$2c, $2e
    .byte  $1e, $2e, $2c, $2a, $28, $26, $24, $22
    .byte  $20, $22, $24, $26, $28, $2a, $2c, $2e
    .byte  $1e, $2e, $2c, $2a, $28, $26, $24, $22
    .byte  $20, $22, $24, $26, $28, $2a, $2c, $2e
    .byte  $1e, $2e, $2c, $2a, $28, $26, $24, $22
    .byte  $20, $22, $24, $26, $28, $2a, $2c, $2e
    .byte  $1e, $2e, $2c, $2a, $28, $26, $24, $22
    .byte  $20, $22, $24, $26, $28, $2a, $2c, $2e
    .byte  $1e, $2e, $2c, $2a, $28, $26, $24, $22

SegOfsTbl:
    .byte   0, NUM_SEGS
BlockOfsTbl:
    .byte   0, NUM_BLOCKS
PtrOfsTbl:
    .byte   0, NUM_BLOCKS*4

    align 256

PFTop_OU:
    .ds     OFS+2, $00
    PATTERN_SHL %00000001, 1
PFTop_OUr:
    .ds     OFS+2, $ff
    PATTERN_SHL %11111110, 1
    .ds     OFS+2, $00

    align 256
PFTop_OU2:
    .ds     OFS+2, $00
    PATTERN_SHL %00000001, 2
PFTop_OU2r:
    .ds     OFS+2, $ff
    PATTERN_SHL %11111110, 2
    .ds     OFS+2, $00

    align 256
PFTop_OU3:
    .ds     OFS+2, $00
    PATTERN_SHL %00000001, 3
PFTop_OU3r:
    .ds     OFS+2, $ff
    PATTERN_SHL %11111110, 3
    .ds     OFS+2, $00

    align   256
PFTop_UO:
    .ds     OFS+2, $00
    PATTERN_SHR %10000000, 1
PFTop_UOr:
    .ds     OFS+2, $ff
    PATTERN_SHR %01111111, 1
    .ds     OFS+2, $00


    align 256
PFTop_UO2:
    .ds     OFS+2, $00
    PATTERN_SHR %10000000, 2
PFTop_UO2r:
    .ds     OFS+2, $ff
    PATTERN_SHR %01111111, 2
    .ds     OFS+2, $00

    align 256
PFTop_UO3:
    .ds     OFS+2, $00
    PATTERN_SHR %10000000, 3
PFTop_UO3r:
    .ds     OFS+2, $ff
    PATTERN_SHR %01111111, 3
    .ds     OFS+2, $00

    align 256
PFTop_Horz:
    .ds     OFS+2, $00
PFTop_Horzr:
    .ds     OFS+2, $ff
    .ds     OFS+2, $00

    org $fffc
    .word   Start
    .word   Start
